/*******************************************************************************
 * Author: Jérôme Dubois       Jerome.Dubois@ensimag.imag.fr jerome@stud.ntnu.no
 * Copyright 2007 Jerome Dubois
 *
 *
 ******************************************************************************/

#ifndef _FILTERS_H
#define _FILTERS_H

#include "grim.h"

#ifdef __cplusplus
extern "C" {
#endif

#define DEFINED
#define FALSE 0
#define TRUE  1
#define PI 3.14159265                // 3.141592653589793238462643383279
#define BLACK 0
#define WHITE 255

#define FILTER_LENGTH 16

//static fgrim filter_coef_;
//static fgrim *filter_coef;
extern void init_coef(fgrim *filter_coef);
extern void free_coef(fgrim *filter_coef);
extern int pair_filter_coef(fgrim *lpf, fgrim *hpf);

extern int frequency_shift_PI(fgrim *fimg);
extern int downsample_quincunx_q2(fgrim *in, fgrim *outb1, fgrim *outb2);
extern int upsample_quincunx_q2(fgrim *out, fgrim *inb1, fgrim *inb2);
extern int filter_periodic_horizontal(fgrim *fg, fgrim *coef, int offset);
extern int filter_periodic_vertical(fgrim *fg, fgrim *coef, int offset);
extern int reorganize_h2v(fgrim *fin, fgrim *fout);
extern int reorganize_v2h(fgrim *fin, fgrim *fout);
extern int polyphase_combine(const fgrim *ib1, const fgrim *ib2, fgrim *ob1, fgrim *ob2);

extern int amplify(fgrim *signal, float gain);

#ifdef __cplusplus
}
#endif

#endif // #ifndef _FILTERS_H
