/*******************************************************************************
 * Author: Jérôme Dubois       Jerome.Dubois@ensimag.imag.fr jerome@stud.ntnu.no
 * Copyright 2008 Jerome Dubois
 * 
 ******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h> 
#include <math.h>

#include "grim.h"

/*******************************************************************************
* main: creates images twodir.{bmp,grim} which contains info in 2 directions
*******************************************************************************/
int main(int argc, char* argv[]){
  int row, col, w, h;
  float t;
  fgrim sin_1pi4, sin_3pi4, twodir;
  grim twodir_grim;
  
  w = 60; h = w;
  fgrim_create(&sin_1pi4, w, h);
  fgrim_create(&sin_3pi4, w, h);
  fgrim_create(&twodir, w, h);
  
  // computation of twodir
  fgrim_set_sinus(&sin_1pi4, WHITE, 1*PI/4.0, 60); // period of 60 pixel
  fgrim_set_sinus(&sin_3pi4, WHITE, 3*PI/4.0, 30);
  for (row=0; row<h; row++){ // for each row
    for (col=0; col<w; col++){ // for each column
      t = 3 * sin_1pi4.pix[row*w+col] + 2 * sin_3pi4.pix[row*w+col] ;
      twodir.pix[row*w+col] = t / 5.0 ;
    }
  }
  fgrim_to_grim(&twodir,&twodir_grim);
  grim_write_grim(&twodir_grim, "twodir.grim");
  grim_write_bmp(&twodir_grim, "twodir.bmp");
  
  fgrim_free(&sin_1pi4);
  fgrim_free(&sin_3pi4);
  fgrim_free(&twodir);
  grim_free(&twodir_grim);

  return EXIT_SUCCESS;
}

/*******************************************************************************
* test_3: test grim_set_sinus
* 
*******************************************************************************/
int test_3(){
int w, h;
  grim g;
  int w = 80;
  int h = w;
  grim_create(&g, w, h);
  grim_set_sinus(&g, WHITE, 1*PI/4.0, 5);
  grim_write_bmp(&g, "sinus_image.bmp");
  grim_free(&g);
  

  return EXIT_SUCCESS;
}



/*******************************************************************************
* test_6: 
* 
*******************************************************************************/
int test_6(){
  int w, h;
  fgrim sin1, sin2;
  grim g;
  w = 128;
  h = 128;
  
  fgrim_create( &f, w, h);
  fgrim_set_sinus( &f, WHITE, 0, 5);
  fgrim_to_grim( &f, &g);
  grim_write_grim( &g, IMAGES"sin_0_5_128x128.grim");
  grim_free( &g);
  fgrim_free( &f);
  
  fgrim_create( &f, w, h);
  fgrim_set_sinus( &f, WHITE, 0, 20);
  fgrim_to_grim( &f, &g);
  grim_write_grim( &g, IMAGES"sin_0_20_128x128.grim");
  grim_free( &g);
  fgrim_free( &f);
  
  fgrim_create( &f, w, h);
  fgrim_set_sinus( &f, WHITE, 0, 50);
  fgrim_to_grim( &f, &g);
  grim_write_grim( &g, IMAGES"sin_0_50_128x128.grim");
  grim_free( &g);
  fgrim_free( &f);

  return EXIT_SUCCESS;
}

// -EOF-
