source('PIshift.m');
source('downsample_b1.m');
source('downsample_b2.m');
source('downsample.m');
source('fph.m');
source('reorganize_h2v.m');
source('fpv.m');

function [matA8b1,matA8b2]=dfb(matA1,f)
% function dfb (directional filterbank)
% Return: the output of a two band directional filterbank
% Param:
%    f : filter coef
%    im: image (matrix) to filter
%
    
    % param check
    n = size(matA1)(1);
    if ( n != size(matA1)(2) )    disp('Error (dfb): The matrix should be square'); end
    if ( mod(n         ,2) != 0 ) disp('Error (dfb): The matrix must have even dimensions'); end
    if ( mod(size(f)(2),2) != 0 ) disp('Error (dfb): The filter must have even dimensions'); end
    
    % filter preparation
    f0 = f;
    f1 = pair_filter(f);
    
    matA2   = PIshift(matA1);
    %matA4b1 = downsample_b1(matA2, n, n/2);
    %matA4b2 = downsample_b2(matA2, n, n/2);
    [matA4b1,matA4b2] = downsample(matA2) ;

    matA5b1 = fph( matA4b1 ,f );
    matA5b2 = fph( matA4b2 ,f );
    
    matA6b1 = reorganize_h2v( matA5b1 );
    matA6b2 = reorganize_h2v( matA5b2 );
    
    matA7b1 = fpv( matA6b1 ,f ) ;
    matA7b2 = fpv( matA6b2 ,f ) ;
    
    matA8b1 = matA7b1 + matA7b2 ;
    matA8b2 = matA7b1 - matA7b2 ;
return

