source('fph_raw.m');
function out=fph(im,f)
% function fph (filter_periodic_horizontal)
% Return: the output of im filtered with filter f
% each raw is filtered invidually and considered periodic
% Param:
%    f : filter coef
%    im: image (matrix) to filter
% 
    nb_raw = size(im)(1);
    nb_col = size(im)(2);
    f_size = size(f)(2);
    out = zeros(size(im));
    for raw = 1 : nb_raw % for each raw
        out(raw,:) = fph_raw(im(raw,:),f);
    end
return

% octave:63> fph([1:4;5:8],f1)
% ans =
% 
%    15   13   15   17
%    39   37   39   41

