
function out=fph_big_raw(im,f)
% function fph (filter_periodic_horizontal)
% Return: the output of im filtered with filter f
% ATTENTION: this function consider that the matrix is one big raw, obtained by
%            concatenation of all raws. This is not what we want for the DFB.
% Param:
%    f : filter coef
%    im: image (matrix) to filter
% 
    offset = 4; % any number OK. Just change by which value we begin.
    nb_raw = size(im)(1);
    nb_col = size(im)(2);
    im_size = nb_col * nb_raw ;
    f_size = size(f)(2);
    res = zeros(1,im_size);
    im_flat = reshape(im', 1, im_size);
    for cell = 1 : im_size % for each cell, we compute out(cell)
        for f_ind = 1 : f_size % for each filter coeff
           res(cell) += \
              im_flat( mod(cell-offset+f_ind,im_size) +1 ) * f(f_ind) ;
       end
    end
    out = reshape(res,nb_col,nb_raw)' ;
return

