source('fpv_col.m');

function out=fpv(im,f)
% function fpv (filter_periodic_vertical)
% Return: the output of im filtered vertically with filter f
% each column is filtered invidually and considered periodic
% Param:
%    f : filter coef
%    im: image (matrix) to filter
% 
    nb_raw = size(im)(1);
    nb_col = size(im)(2);
    f_size = size(f)(2);
    out = zeros(size(im));
    for col = 1 : nb_col % for each column
        out(:,col) = fpv_col(im(:,col),f);
    end
return

% octave:69> fpv([1:4;5:8]',f1)
% ans =
% 
%    15   39
%    13   37
%    15   39
%    17   41

