
function out=fpv_col(col,f)
% function fpv_col (filter_periodic_vertical_col)
% Return: the output of col filtered with filter f. col is considered periodic.
% Param:
%    f : filter coef
%    col: column to filter
% 
    offset = 4; % any number OK. Just change by which value we begin.
    nb_raw = size(col)(1);
    nb_col = size(col)(2);
    if (nb_col != 1) disp('Error (fpv_col): more than one column'); end
    
    f_size = size(f)(2);
    out = zeros(nb_raw,1);
    for cell = 1 : nb_raw % for each cell, we compute out(cell)
        for f_ind = 1 : f_size % for each filter coeff
           out(cell) += col( mod(cell-offset+f_ind,nb_raw) +1 ) * f(f_ind) ;
        end
        %if out(cell)<0, out(cell)=0; end
    end
return

% fpv_col([1:4]',f1)
