
more off % scrolling
source('symetric.m');    % function out=symetric(m)
source('downsample_b1.m');  % function out=downsample_b1(in, out_w, out_h)
source('fph.m');         % function out=fph(im,f)
source('fpv.m');         % function out=fpv(im,f)
source('in_grey_range.m'); % function out=in_grey_range(m)

% sinus1: a test matrix
%load('sinus1.mat');     % grim_set_sinus(&sinus1, 200, 11*PI/12.0, 100);

% twodir: a square test matrix, with two directions.
load('twodir_350x350.mat'); % the matrix is called "twodir"
 
% m1: a test matrix, for example to be downsampled
m1=[];
h = 8;
w = 6;
for raw = 1:h
  for col = 1:w
    m1(raw,col)= (7-raw+1)*6+1+col-1;
  end
end

% m2: a square test matrix
m2=[];
h= 8;
w= h;
for raw = 1:h
  for col = 1:w
    m2(raw,col)= (raw-1)*w + col-1;
  end
end

% m3: a square test matrix
m3=[];
h= 4;
w= h;
for raw = 1:h
  for col = 1:w
    m3(raw,col)= (raw-1)*w + col-1;
  end
end


% f1: a filter coefficient vector
f1 = [1,2,2,1];
f2 = [.1, .4, .4, .1];
f3 = [ .93871500e-02, \
      -.70651830e-01, \
       .69428270e-01, \
       .48998080e+00, \
       .48998080e+00, \
       .69428270e-01, \
      -.70651830e-01, \
       .93871500e-02]; % from ASGDIP page 218. "Table 5.5: QMF FB Coeff" 8A

% main1
disp('We will process the image:')
image = m2;  %twodir;
disp('It is represented by the matrix:')
matrix = symetric(image)
disp('After downsampling, we get the matrix:')
downsampled = downsample_b1(matrix, size(image)(1), size(image)(1)/2) % downsample(in, out_w, out_h)
disp('which correspond to image:')
%symetric(downsampled) % to print only
disp('We use the filter:')
filter = f3
disp('Filtering the downsampled matrix horizontally yields:')
filtered_h = fph(downsampled,filter) % fph(im,f)
%floor(filtered_h) % to print only
disp('We use the filter:')
filter = filter;
disp('and we filter vertically:')
filtered_v = fpv(filtered_h,filter) % fpv(im,f)
%floor(filtered_v) % to print only
disp('We round to integer values in [0,255]:')
filtered_v_grey = in_grey_range(filtered_v)
disp('Finally, the output image is:')
image_out = symetric(floor(filtered_v_grey));
disp('End of main1')





% Online Octave and Matlab course
% http://enacit1.epfl.ch/cours_matlab/
% save -ascii file.txt var1 filtered_v var3

% save -text sinus1_filtered.mat image_out





